#! /usr/bin/python
"""

@ R.B.Young
"""

from ete3 import NCBITaxa
import sys
import os
import csv
import pandas as pd
import argparse


lowfalserecall = []
lowfalseprecision = []
lowfalseF1 = []
hightruerecall = []
hightrueprecision = []
hightrueF1 = []
lowtrueprecision = []
lowtruerecall = []
lowtrueF1 = []
highfalseprecision = []
highfalserecall = []
highfalseF1 = []


def combine(filelist, filename):
	with open(filename, 'w') as writefile:
		writer = csv.writer(writefile)
		writer.writerow(["filename", "phyla", "class", "order", "family", "genus", "species"])
		for f in filelist:
			writelist = []
			sample = f.split("/")[-1].split("_CCMET")[0]
			writelist.append(sample)
			openfile = open(f, 'r')
			reader = csv.reader(openfile)
			linecount = 0
			for line in reader:
				if linecount == 1:
					for value in line:
						writelist.append(value)
				linecount = linecount + 1
			writer.writerow(writelist)

	



basepath = 'CCMetagen/TAXONOMIC_PRF1/'
for filename in os.listdir(basepath):
	if filename.startswith("ani"):
		complexity =filename.split("_")[1]
		strains = filename.split("_")[2]
		PR = filename.split("_")[5]
		file = os.path.join(basepath, filename)
		taxorread = filename.split("_")[6] #is it TAX or READLEVEL
		if complexity == "cLOW" and strains == "stFalse" and PR == "RECALL":
			lowfalserecall.append(file)
		elif complexity == "cLOW" and strains == "stFalse" and PR == "PRECISION":
			lowfalseprecision.append(file)
		elif complexity == "cLOW" and strains == "stFalse" and PR == "F1SCORE":
			lowfalseF1.append(file)
		elif complexity == "cHIGH" and strains == "stTrue" and PR == "RECALL":
			hightruerecall.append(file)
		elif complexity =="cHIGH" and strains == "stTrue" and PR == "PRECISION":
			hightrueprecision.append(file)
		elif complexity =="cHIGH" and strains == "stTrue" and PR == "F1SCORE":
			hightrueF1.append(file)
		elif complexity == "cLOW" and strains == "stTrue" and PR == "PRECISION":
			lowtrueprecision.append(file)
		elif complexity == "cLOW" and strains == "stTrue" and PR == "RECALL":
			lowtruerecall.append(file)
		elif complexity == "cLOW" and strains == "stTrue" and PR == "F1SCORE":
			lowtrueF1.append(file)
		elif complexity == "cHIGH" and strains == "stFalse" and PR == "PRECISION":
			highfalseprecision.append(file)
		elif complexity =="cHIGH" and strains == "stFalse" and PR == "RECALL":
			highfalserecall.append(file)
		elif complexity =="cHIGH" and strains == "stFalse" and PR == "F1SCORE":
			highfalseF1.append(file)

combine(lowfalserecall, ("CCMET_LOW_FALSE_RECALL_" + str(taxorread) + ".csv.csv"))
combine(lowfalseprecision, ("CCMET_LOW_FALSE_PRECISION_" + str(taxorread) + ".csv.csv"))
combine(hightruerecall, ("CCMET_HIGH_TRUE_RECALL_"+ str(taxorread) + ".csv.csv"))
combine(hightrueprecision, ("CCMET_HIGH_TRUE_PRECISION_"+ str(taxorread) + ".csv.csv"))
combine(lowtruerecall, ("CCMET_LOW_TRUE_RECALL_"+ str(taxorread) + ".csv.csv"))
combine(lowtrueprecision, ("CCMET_LOW_TRUE_PRECISION_"+ str(taxorread) + ".csv.csv"))
combine(highfalseprecision, ("CCMET_HIGH_FALSE_PRECISION_" + str(taxorread) + ".csv.csv"))
combine(highfalserecall, ("CCMET_HIGH_FALSE_RECALL_" + str(taxorread) + ".csv.csv"))
combine(lowfalseF1, ("CCMET_LOW_FALSE_F1_" + str(taxorread) + ".csv.csv"))
combine(hightrueF1, ("CCMET_HIGH_TRUE_F1_" + str(taxorread) + ".csv.csv"))
combine(lowtrueF1, ("CCMET_LOW_TRUE_F1_" + str(taxorread) + ".csv.csv"))
combine(highfalseF1, ("CCMET_HIGH_FALSE_F1_" + str(taxorread) + ".csv.csv"))

		