#! /usr/bin/python
"""

@ R.B.Young
Created on Aug 2021
"""


from ete3 import NCBITaxa
import sys
import os
import csv
import pandas as pd
import argparse


lowfalserecall = []
lowfalseprecision = []
lowfalseF1 = []
hightruerecall = []
hightrueprecision = []
hightrueF1 = []
lowtrueprecision = []
lowtruerecall = []
lowtrueF1 = []
highfalseprecision = []
highfalserecall = []
highfalseF1 = []


def combine(filelist, filename):
	with open(filename, 'w') as writefile:
		writer = csv.writer(writefile)
		writer.writerow(["filename", "phyla", "class", "order", "family", "genus", "species"])
		for f in filelist:
			writelist = []
			sample = f.split("/")[-1].split("_")[0] + "_" + f.split("/")[-1].split("_")[1] + "_" + f.split("/")[-1].split("_")[2] + "_" + f.split("/")[-1].split("_")[3]
			writelist.append(sample)
			openfile = open(f, 'r')
			reader = csv.reader(openfile)
			linecount = 0
			for line in reader:
				if linecount == 1:
					for value in line:
						value = value.strip("/n")
						writelist.append(value)
				linecount = linecount + 1
			writer.writerow(writelist)



basepath = 'MetaPhlAn/Metaphlan_Individual_PRF1_Tax'
for filename in os.listdir(basepath):
	if filename.startswith("ani"):
		complexity =filename.split("_")[1]
		strains = filename.split("_")[2]
		PR = filename.split("_")[4]
		file = os.path.join(basepath, filename)
		taxorread = filename.split("_")[5] #is it TAX or READLEVEL
		if complexity == "cLOW" and strains == "stFalse" and PR == "RECALL":
			lowfalserecall.append(file)
		elif complexity == "cLOW" and strains == "stFalse" and PR == "PRECISION":
			lowfalseprecision.append(file)
		elif complexity == "cLOW" and strains == "stFalse" and PR == "F1SCORE":
			lowfalseF1.append(file)
		elif complexity == "cHIGH" and strains == "stTrue" and PR == "RECALL":
			hightruerecall.append(file)
		elif complexity =="cHIGH" and strains == "stTrue" and PR == "PRECISION":
			hightrueprecision.append(file)
		elif complexity =="cHIGH" and strains == "stTrue" and PR == "F1SCORE":
			hightrueF1.append(file)
		elif complexity == "cLOW" and strains == "stTrue" and PR == "PRECISION":
			lowtrueprecision.append(file)
		elif complexity == "cLOW" and strains == "stTrue" and PR == "RECALL":
			lowtruerecall.append(file)
		elif complexity == "cLOW" and strains == "stTrue" and PR == "F1SCORE":
			lowtrueF1.append(file)
		elif complexity == "cHIGH" and strains == "stFalse" and PR == "PRECISION":
			highfalseprecision.append(file)
		elif complexity =="cHIGH" and strains == "stFalse" and PR == "RECALL":
			highfalserecall.append(file)
		elif complexity =="cHIGH" and strains == "stFalse" and PR == "F1SCORE":
			highfalseF1.append(file)

combine(lowfalserecall, ("MetaPhlAn_LOW_FALSE_RECALL_" + str(taxorread) + ".csv"))
combine(lowfalseprecision, ("MetaPhlAn_LOW_FALSE_PRECISION_" + str(taxorread) + ".csv"))
combine(hightruerecall, ("MetaPhlAn_HIGH_TRUE_RECALL_"+ str(taxorread) + ".csv"))
combine(hightrueprecision, ("MetaPhlAn_HIGH_TRUE_PRECISION_"+ str(taxorread) + ".csv"))
combine(lowtruerecall, ("MetaPhlAn_LOW_TRUE_RECALL_"+ str(taxorread) + ".csv"))
combine(lowtrueprecision, ("MetaPhlAn_LOW_TRUE_PRECISION_"+ str(taxorread) + ".csv"))
combine(highfalseprecision, ("MetaPhlAn_HIGH_FALSE_PRECISION_" + str(taxorread) + ".csv"))
combine(highfalserecall, ("MetaPhlAn_HIGH_FALSE_RECALL_" + str(taxorread) + ".csv"))
combine(lowfalseF1, ("MetaPhlAn_LOW_FALSE_F1_" + str(taxorread) + ".csv"))
combine(hightrueF1, ("MetaPhlAn_HIGH_TRUE_F1_" + str(taxorread) + ".csv"))
combine(lowtrueF1, ("MetaPhlAn_LOW_TRUE_F1_" + str(taxorread) + ".csv"))
combine(highfalseF1, ("MetaPhlAn_HIGH_FALSE_F1_" + str(taxorread) + ".csv"))

		