#! /usr/bin/python
"""
@ R.B.Young
Created on 30 Aug 2021
"""
import sys
import os
import csv
import numpy as np
import argparse
import pandas as pd
import subprocess


title = ["phylum", "class", "order", "family", "genus", "species"]
outputpath = "Precision_and_Recall/Graphing_DataFrames/"
finaldf = pd.DataFrame()
datatype =  ""
Toolnames = ["CCMetagen", "Kraken2", "Metacache", "MetaPhlAn", "ExPAM", "Phyloflash"]

readbasepath = 'Precision_and_Recall/Read_PR'
taxbasepath = 'Precision_and_Recall/TaxonomicPR/'


listdict = {"LOW_TRUE_F1_READ":[], "LOW_FALSE_RECALL_READ":[], "HIGH_FALSE_F1_READ":[], "LOW_FALSE_PRECISION_READ":[], "HIGH_FALSE_PRECISION_READ":[],"LOW_TRUE_PRECISION_READ":[], "HIGH_TRUE_F1_READ":[], 
"LOW_TRUE_RECALL_READ":[], "HIGH_FALSE_RECALL_READ":[], "LOW_FALSE_F1_READ":[], "HIGH_TRUE_PRECISION_READ":[], "HIGH_TRUE_RECALL_READ":[], "LOW_TRUE_F1_TAX":[], "LOW_FALSE_RECALL_TAX":[], "HIGH_FALSE_F1_TAX":[],
"LOW_FALSE_PRECISION_TAX":[], "HIGH_FALSE_PRECISION_TAX":[], "LOW_TRUE_PRECISION_TAX":[], "HIGH_TRUE_F1_TAX":[], "LOW_TRUE_RECALL_TAX":[],
"HIGH_FALSE_RECALL_TAX":[], "LOW_FALSE_F1_TAX":[], "HIGH_TRUE_PRECISION_TAX":[], "HIGH_TRUE_RECALL_TAX":[]}

#segregate by file type (as per the lsitdict keys)
def separatebycategory(directorypath):
	
	for file in os.listdir(directorypath):
		if file.endswith(".csv.csv"):
			print(file)
			filepath = os.path.join(directorypath, file)
			category =(file.split("_", 1)[1]).split(".csv")[0]
			for listtype in listdict.keys():
				if "READ" in file:
					forthatlisttype = str(listtype) + str("LEVEL")
					if forthatlisttype == category:
						listdict[listtype].append(filepath)
				elif "TAX" in file:
					forthatlisttype = str(listtype)
					if forthatlisttype == category:
						listdict[listtype].append(filepath)

#open all the files and send them to the function 
for root, directory, files in os.walk(taxbasepath):
	for name in directory:
		if name in Toolnames:
			if os.path.exists(os.path.join(readbasepath, name)):
				separatebycategory(os.path.join(readbasepath, name))
			else:
				print(os.path.join(readbasepath, name))
			if os.path.exists(os.path.join(taxbasepath, name)):
				separatebycategory(os.path.join(taxbasepath, name))
			else:
				print(os.path.join(taxbasepath, name))



for key in listdict.keys():
	type = key.split("_")[2]
	finaldf = None
	paths = listdict[key]
	for path in paths:
		tool = (path.split("/")[-1]).split("_")[0]
		if tool == "KRAKEN":
			tool = "Kraken2"
		if tool == "METACACHE":
			tool = "Metacache"
		if tool == "CLARK":
			tool = "Clark"
		if tool == "PHYLOFLASH":
			tool = "PhyloFlash"
		if tool == "CCMET":
			tool = "CCMetagen"
		if tool == "EXPAM":
			tool = "expam"
		if tool == "MetaPhlAn":
			tool = "MetaPhlAn3"
		datatype =  (str(path.split("/")[-1]).split("_",1)[1]).split(".")[0]
		df = pd.read_csv(path)
		df = df.rename(columns={'phyla':'Phylum', 'class':'Class', 'order':'Order', 'family':'Family', 'genus':'Genus', 'species':'Species'})
		df.replace({'/n':""}, regex=True)
		df = df.loc[:, (df != 0).any(axis=0)]

		if len(df.columns) > 6:
			df = df.iloc[:, 1:]	
		toolcol = [tool]* len(df)
		#insert a column with the tool name
		df.insert(0, "tool", toolcol)
		df_melt = pd.melt(df, id_vars=["tool"])

		finaldf = pd.concat([finaldf, df_melt], axis=0)
		finaldf["value"] = pd.to_numeric(finaldf["value"])


		finalloc = outputpath + datatype + str("_DataTableBOXPLOT10-5-22.csv")
		outputgraph = "Precision_and_Recall/Graphs/Boxplots_10-5-22/" + datatype + str("_boxplot.pdf")
	finaldf["value"] = finaldf["value"]*100
	print(finaldf)
	finaldf.to_csv(finalloc)
	print("DONE: your datatable can be found in -" + str(finalloc))

	#now make the graphs for each finalloc and store them in the graphs folder
	print("making box plots...")
	commands = ["Rscript", "Precision_and_Recall/Graphing_scripts/PRF1_graphing_dotboxplot.R"]
	arguments = [str(finalloc), str(outputgraph), str(datatype), str(type)]
	subprocess.call(commands + arguments)